import {ErrorResponseFactory} from "./ErrorResponseFactory";
import {HTTPError} from "../HTTPError";
import {HTTPStatus} from "@extollo/util"

export function http(status: HTTPStatus, message?: string, output: 'json' | 'html' | 'auto' = 'auto'): HTTPErrorResponseFactory {
    return new HTTPErrorResponseFactory(new HTTPError(status, message), output)
}

export class HTTPErrorResponseFactory extends ErrorResponseFactory {
    constructor(
        public readonly error: HTTPError,
        output: 'json' | 'html' | 'auto' = 'auto',  // FIXME xml support
    ) {
        super(error, error.status, output)
    }
}
