import {CanonicalStatic} from "./CanonicalStatic";
import {Singleton, Instantiable} from "@extollo/di";
import {Controller} from "../http/Controller";
import {CanonicalDefinition} from "./Canonical";

@Singleton()
export class Controllers extends CanonicalStatic<Instantiable<Controller>, Controller> {
    protected appPath = ['http', 'controllers']
    protected canonicalItem = 'controller'
    protected suffix = '.controller.js'

    public async initCanonicalItem(definition: CanonicalDefinition) {
        const item = await super.initCanonicalItem(definition)
        if ( !(item.prototype instanceof Controller) ) {
            throw new TypeError(`Invalid controller definition: ${definition.originalName}. Controllers must extend from @extollo/lib.http.Controller.`)
        }

        return item
    }
}
