import {CanonicalStatic} from "./CanonicalStatic";
import {Singleton, Instantiable} from "@extollo/di";
import {CanonicalDefinition} from "./Canonical";
import {Middleware} from "../http/routing/Middleware";

@Singleton()
export class Middlewares extends CanonicalStatic<Instantiable<Middleware>, Middleware> {
    protected appPath = ['http', 'middlewares']
    protected canonicalItem = 'middleware'
    protected suffix = '.middleware.js'

    public async initCanonicalItem(definition: CanonicalDefinition) {
        const item = await super.initCanonicalItem(definition)
        if ( !(item.prototype instanceof Middleware) ) {
            throw new TypeError(`Invalid middleware definition: ${definition.originalName}. Controllers must extend from @extollo/lib.http.routing.Middleware.`)
        }

        return item
    }
}
